#ifndef CHIP_MMAP_H
#define CHIP_MMAP_H

#include "chip_devtype_mem.h"

/* CODE MEMORY */
#define CHIP_MEMRGN_ADDR_FLASH                0x08000000UL
#define CHIP_MEMRGN_ADDR_ESIG                 0x1FFFF7E0UL
//#define CHIP_MEMRGN_ADDR_FLASH_SIZE           0x1FFFF7E0UL /*!< FLASH Size register base address */
//#define CHIP_MEMRGN_ADDR_OPTION_BYTES         0x1FFFF800UL
#ifdef CHIP_DEV_CH32XXXX
#define CHIP_MEMRGN_ADDR_VENDOR               0x1FFFF700UL
#endif
#define CHIP_MEMRGN_ADDR_SYSMEM               0x1FFFF000UL


/* RAM */
#define CHIP_MEMRGN_ADDR_SRAM                 0x20000000UL

/* Peripherals */
#define CHIP_MEMRGN_ADDR_APB1                 0x40000000UL
#define CHIP_MEMRGN_ADDR_APB2                 0x40010000UL
#define CHIP_MEMRGN_ADDR_AHB                  0x40020000UL
#define CHIP_MEMRGN_ADDR_CORE_INTERNAL        0xE0000000UL

#define CHIP_MEMRGN_ADDR_DBGMCU               0xE0042000UL


/* Адреса блоков периферии */
#define CHIP_MEMRGN_ADDR_PERIPH_TIM2          (CHIP_MEMRGN_ADDR_APB1 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM3          (CHIP_MEMRGN_ADDR_APB1 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM4          (CHIP_MEMRGN_ADDR_APB1 + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM5          (CHIP_MEMRGN_ADDR_APB1 + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM6          (CHIP_MEMRGN_ADDR_APB1 + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM7          (CHIP_MEMRGN_ADDR_APB1 + 0x1400)
#ifdef CHIP_DEV_CH32XXXX
#define CHIP_MEMRGN_ADDR_PERIPH_UART6         (CHIP_MEMRGN_ADDR_APB1 + 0x1800)
#define CHIP_MEMRGN_ADDR_PERIPH_UART7         (CHIP_MEMRGN_ADDR_APB1 + 0x1C00)
#define CHIP_MEMRGN_ADDR_PERIPH_UART8         (CHIP_MEMRGN_ADDR_APB1 + 0x2000)
#else
#define CHIP_MEMRGN_ADDR_PERIPH_TIM12         (CHIP_MEMRGN_ADDR_APB1 + 0x1800)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM13         (CHIP_MEMRGN_ADDR_APB1 + 0x1C00)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM14         (CHIP_MEMRGN_ADDR_APB1 + 0x2000)
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_RTC           (CHIP_MEMRGN_ADDR_APB1 + 0x2800)
#define CHIP_MEMRGN_ADDR_PERIPH_WWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_IWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI2          (CHIP_MEMRGN_ADDR_APB1 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_I2S2          (CHIP_MEMRGN_ADDR_APB1 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI3          (CHIP_MEMRGN_ADDR_APB1 + 0x3C00)
#define CHIP_MEMRGN_ADDR_PERIPH_I2S3          (CHIP_MEMRGN_ADDR_APB1 + 0x3C00)
#define CHIP_MEMRGN_ADDR_PERIPH_USART2        (CHIP_MEMRGN_ADDR_APB1 + 0x4400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART3        (CHIP_MEMRGN_ADDR_APB1 + 0x4800)
#define CHIP_MEMRGN_ADDR_PERIPH_UART4         (CHIP_MEMRGN_ADDR_APB1 + 0x4C00)
#define CHIP_MEMRGN_ADDR_PERIPH_UART5         (CHIP_MEMRGN_ADDR_APB1 + 0x5000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C1          (CHIP_MEMRGN_ADDR_APB1 + 0x5400)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C2          (CHIP_MEMRGN_ADDR_APB1 + 0x5800)
#define CHIP_MEMRGN_ADDR_PERIPH_USBD          (CHIP_MEMRGN_ADDR_APB1 + 0x5C00)
#define CHIP_MEMRGN_ADDR_PERIPH_USBCAN_SRAM   (CHIP_MEMRGN_ADDR_APB1 + 0x6000)
#define CHIP_MEMRGN_ADDR_PERIPH_CAN1          (CHIP_MEMRGN_ADDR_APB1 + 0x6400)
#define CHIP_MEMRGN_ADDR_PERIPH_CAN2          (CHIP_MEMRGN_ADDR_APB1 + 0x6800)
#define CHIP_MEMRGN_ADDR_PERIPH_BKP           (CHIP_MEMRGN_ADDR_APB1 + 0x6C00)
#define CHIP_MEMRGN_ADDR_PERIPH_PWR           (CHIP_MEMRGN_ADDR_APB1 + 0x7000)
#define CHIP_MEMRGN_ADDR_PERIPH_DAC           (CHIP_MEMRGN_ADDR_APB1 + 0x7400)

#define CHIP_MEMRGN_ADDR_PERIPH_AFIO          (CHIP_MEMRGN_ADDR_APB2 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_EXTI          (CHIP_MEMRGN_ADDR_APB2 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIO(n)       (CHIP_MEMRGN_ADDR_PERIPH_GPIOA + (0x400*n))
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOA         (CHIP_MEMRGN_ADDR_APB2 + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOB         (CHIP_MEMRGN_ADDR_APB2 + 0x0C00)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOC         (CHIP_MEMRGN_ADDR_APB2 + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOD         (CHIP_MEMRGN_ADDR_APB2 + 0x1400)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOE         (CHIP_MEMRGN_ADDR_APB2 + 0x1800)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOF         (CHIP_MEMRGN_ADDR_APB2 + 0x1C00)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOG         (CHIP_MEMRGN_ADDR_APB2 + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC1          (CHIP_MEMRGN_ADDR_APB2 + 0x2400)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC2          (CHIP_MEMRGN_ADDR_APB2 + 0x2800)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM1          (CHIP_MEMRGN_ADDR_APB2 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI1          (CHIP_MEMRGN_ADDR_APB2 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2S1          (CHIP_MEMRGN_ADDR_APB2 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM8          (CHIP_MEMRGN_ADDR_APB2 + 0x3400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART1        (CHIP_MEMRGN_ADDR_APB2 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC3          (CHIP_MEMRGN_ADDR_APB2 + 0x3C00)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM9          (CHIP_MEMRGN_ADDR_APB2 + 0x4C00)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM10         (CHIP_MEMRGN_ADDR_APB2 + 0x5000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM11         (CHIP_MEMRGN_ADDR_APB2 + 0x5400)
#define CHIP_MEMRGN_ADDR_PERIPH_SDIO          (CHIP_MEMRGN_ADDR_AHB  - 0x8000)
#define CHIP_MEMRGN_ADDR_PERIPH_DMA1          (CHIP_MEMRGN_ADDR_AHB  + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_DMA2          (CHIP_MEMRGN_ADDR_AHB  + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_RCC           (CHIP_MEMRGN_ADDR_AHB  + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_FLASH         (CHIP_MEMRGN_ADDR_AHB  + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_CRC           (CHIP_MEMRGN_ADDR_AHB  + 0x3000)
#ifdef CHIP_DEV_CH32XXXX
#define CHIP_MEMRGN_ADDR_PERIPH_USBHS         (CHIP_MEMRGN_ADDR_AHB  + 0x3400)
#define CHIP_MEMRGN_ADDR_PERIPH_EXTEND        (CHIP_MEMRGN_ADDR_AHB  + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_TRNG          (CHIP_MEMRGN_ADDR_AHB  + 0x3C00)
#define CHIP_MEMRGN_ADDR_PERIPH_BLE           (CHIP_MEMRGN_ADDR_AHB  + 0x4000)
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_ETH           (CHIP_MEMRGN_ADDR_AHB  + 0x8000)
#define CHIP_MEMRGN_ADDR_PERIPH_USBHD         (0x50000000)
#define CHIP_MEMRGN_ADDR_PERIPH_DVP           (0x50050000)

#define CHIP_MEMRGN_ADDR_PERIPH_EXMC          (0xA0000000)

#define CHIP_MEMRGN_ADDR_EXMC_BANK1_1         (0x60000000) /* NOR/PSRAM1 */
#define CHIP_MEMRGN_ADDR_EXMC_BANK1_2         (0x64000000) /* NOR/PSRAM2 */
#define CHIP_MEMRGN_ADDR_EXMC_BANK1_3         (0x68000000) /* NOR/PSRAM3 */
#define CHIP_MEMRGN_ADDR_EXMC_BANK1_4         (0x6C000000) /* NOR/PSRAM4 */
#define CHIP_MEMRGN_ADDR_EXMC_BANK2           (0x70000000) /* NAND1 */
#define CHIP_MEMRGN_ADDR_EXMC_BANK3           (0x80000000) /* NAND2 */
#define CHIP_MEMRGN_ADDR_EXMC_BANK4           (0x90000000) /* PCCARD */









#endif // CHIP_MMAP_H
